#!/usr/bin/env node
import t from "chalk";
import { execSync as l } from "node:child_process";
import g, { resolve as R } from "node:path";
import d, { existsSync as C, rmSync as f } from "node:fs";
import a from "prompts";
import { onPromptFormStateForSigint as v, lookForParentTarget as D } from "@done-coding/node-tools";
import { getConfigPath as O, batchHandler as U } from "@done-coding/cli-template";
import { getTargetRepoUrl as _, gitCloneCommand as M } from "@done-coding/cli-git";
import I from "yargs";
import { hideBin as L } from "yargs/helpers";
const p = {
  version: "0.9.0",
  name: "create-done-coding",
  description: "项目创建命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "create"
  }
}, A = "git@gitee.com:justsosu/done-coding-cli-config-json.git", j = "自定义模版路径", S = "某个git平台用户仓库", H = `./.${p.name}_temp`;
let y;
const k = async () => (y || (y = (await q()).templateList), y), $ = async () => [
  ...await k(),
  { name: j },
  { name: S }
], x = {
  type: "text",
  name: "projectName",
  message: "请输入项目名称",
  format: (e) => e.trim(),
  validate: (e) => e.length > 0 || "项目名称不能为空",
  onState: v
}, E = async () => ({
  type: "select",
  name: "template",
  message: "请选择模板",
  choices: (await $()).map((o) => ({
    title: o.name,
    value: o.name
  })),
  validate: (o) => o.trim().length > 0 || "模板不能为空",
  onState: v
}), B = {
  type: "confirm",
  name: "saveGitHistory",
  message: "是否保留git历史",
  initial: !1
}, G = (e = "项目已存在，是否删除") => ({
  type: "confirm",
  name: "isRemove",
  message: e
}), Y = {
  type: "text",
  name: "customUrl",
  message: "请输入自定义模板路径",
  validate: (e) => e.trim().length > 0 || "路径不能为空",
  onState: v
}, J = (e) => ({
  type: "text",
  name: "gitCommitMessage",
  message: "请输入git提交信息",
  initial: `feat: 初始化项目${e}`,
  validate: (o) => o.trim().length > 0 || "提交信息不能为空",
  onState: v
}), q = async () => {
  console.log(t.blue("拉取模板列表，请稍等..."));
  const e = g.resolve(
    process.cwd(),
    H
  );
  if (console.log(t.blue(`配置临时目录：${e}`)), d.existsSync(e)) {
    const s = `${e}目录已存在，是否删除？`, { isRemove: r } = await a(G(s));
    r ? d.rmSync(e, { recursive: !0, force: !0 }) : (console.log(t.red(`${e}已存在，请手动删除后再试！`)), process.exit(1));
  }
  l(`git clone ${A} ${e} --depth=1`);
  const o = p.name, c = g.resolve(e, `${o}.json`), h = JSON.parse(d.readFileSync(c, "utf-8"));
  if (!Array.isArray(h.templateList))
    throw new Error("远程配置文件出错，templateList 不是数组");
  return console.log(t.green("模板列表拉取成功！")), d.rmSync(e, { recursive: !0, force: !0 }), h;
}, T = async (e) => {
  const { projectName: o, template: c } = e, s = ((o ?? (await a(x)).projectName) || "").trim();
  if (s.includes(" ") || s.includes("\\") || s.includes("/"))
    return console.log(t.red(`项目名称\`${s}\`不能包含空格或者\\或者/`)), process.exit(1);
  const r = R(process.cwd(), s);
  if (C(r)) {
    const { isRemove: i } = await a(G());
    if (i === !0)
      f(r, { recursive: !0, force: !0 });
    else
      return console.log(t.red("项目已存在")), process.exit(1);
  }
  const m = c ?? (await a(await E())).template;
  let u = "";
  if (m === j) {
    const { customUrl: i } = await a(Y);
    u = i;
  } else if (m === S)
    u = await _();
  else {
    const i = (await $()).find(
      (n) => n.name === m
    );
    if (!i)
      return console.log(t.red(`模板${m}不存在`)), process.exit(1);
    if (!i.url)
      return console.log(t.red(`模板${m}仓库地址不存在`)), process.exit(1);
    u = i.url;
  }
  const w = D(".git");
  console.log(t.blue("正在初始化项目，请稍等...")), l(`git clone ${u} ${s} --depth=1 1>&2`);
  const N = O(r);
  if (N && (await U({
    rootDir: r,
    extraEnvData: {
      $projectName: s
    }
  }), f(N, { force: !0 }), console.log(t.blue("模板项目配置注入成功, 模版项目配置文件已删除"))), console.log(t.blue("项目初始化完成")), w) {
    const i = g.resolve(r), n = g.resolve(i, ".git");
    if (!C(n))
      throw new Error("git目录不存在");
    f(n, { recursive: !0, force: !0 }), console.log(
      t.green(
        `项目创建在父级git仓库${w}中，已删除${s}目录下的.git(${n})`
      )
    );
  } else if ((await a(B)).saveGitHistory)
    l(
      `cd ${r} && git remote rename origin upstream && git fetch --unshallow`
    ), console.log(
      t.green(
        "已经将origin重命名为upstream，后续可以与模板git仓库有完整的交互"
      )
    ), console.log(t.green("已保存git历史记录"));
  else {
    const n = g.resolve(r, ".git");
    f(n, { recursive: !0, force: !0 }), l(`cd ${r} && git init`);
  }
  const { gitCommitMessage: P } = await a(
    J(s)
  );
  l(
    `cd ${r} && git add . && git commit -m '${P}'`
  ), console.log(t.green(`项目${s}初始化完成`)), console.log(
    t.blue(`
使用步骤: 
  1. cd ${s}
  2. pnpm install
  3. pnpm run dev
  `)
  );
}, z = async () => ({
  projectName: {
    type: "string",
    alias: "p",
    describe: x.message
  },
  template: {
    type: "string",
    alias: "t",
    choices: (await $()).map((e) => e.name),
    describe: (await E()).message
  }
}), b = p.cliConfig.moduleName, K = (e, o) => {
  console.log(e ? t.red(e) : t.red(o.message)), process.exit(1);
}, Q = p.description, V = `Usage: $0 ${b} [options]`, W = "Usage: $0 [options]", F = async (e, o) => {
  const c = await z();
  return e.strict().usage(o).help("help").version(p.version).alias("v", "version").alias("h", "help").options(c).command(M).fail(K).argv;
}, X = (e) => F(e, V), me = {
  command: b,
  describe: Q,
  builder: X,
  handler: T
}, le = async () => {
  const e = I(L(process.argv)), o = await F(e, W);
  return T(o);
};
export {
  me as a,
  le as c,
  T as h
};
